(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

open S3
open Prins

let _ = 
  let alice = {id="alice"; cert="alice.pub"; ip="127.0.0.1"; port=8001} in
  let bob = {id="bob"; cert="bob"; ip="127.0.0.1"; port=8002} in
  let charlie = {id="charlie"; cert="charlie"; ip="127.0.0.1"; port=8003} in
    register alice; register bob; register charlie


let say s = Printf.printf "\nOffice: %s.\n\n" s
let log s id () = say s 

let request id date =
  say ("running with "^id.customer^" and "^id.store);
  Contract(date,
  { hConfirm = log "run confirmed";
    hAbort = log "run aborted"; })

let _ = officer "charlie" {hRequest = request}
