(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)

open Rpc
open Printf
open Prins

let _ = 
  let alice = {id="alice"; cert="alice"; ip="127.0.0.1"; port=8001} in
  let bob = {id="bob"; cert="bob"; ip="127.0.0.1"; port=8002} in
  register alice; register bob

let start_client () =
  let prins = {client = "alice";
               server = "bob"} in
  let num = client prins (Query("Number?",{hResponse = fun _ i -> i})) in
  printf "Answer is %i\n" num

let start_server () =
  server "bob" {hQuery = fun _ _ -> Response(42,())}

let _ = Pi.fork start_server
let _ = start_client ()
