(* This file belongs to the Secure Sessions Project 	      *)
(* http://www.msr-inria.inria.fr/projects/sec/sessions/       *)
(* MSR-INRIA Joint Centre, 2007    			      *)


type pr = { id:string; cert:string; ip:string; port:int;}

val register : pr -> unit

val psend : string -> Data.str -> unit
val precv : string -> Data.str

val get_privkey : Data.str -> Data.bytes
val get_pubkey : Data.str -> Data.bytes

val bind : string -> unit
val close : unit -> unit

val check_cache : string -> int -> Data.bytes -> unit
